////////////////////////////////////////////////////////////////////////
// pixel03.c
// Filling the screen from left to right
// Mochilote - www.cpcmania.com
////////////////////////////////////////////////////////////////////////
#include <stdio.h>
#include <stdlib.h>


unsigned char *GetLineAddress(unsigned char nLine)
{
	return (unsigned char *)0xC000 + ((nLine / 8) * 80) + ((nLine % 8) * 2048);
}

void SetMode0PixelColor(unsigned char *pByteAddress, unsigned char nColor, unsigned char nPixel)
{
	unsigned char nByte = *pByteAddress;

	if(nPixel == 0)
	{
		nByte &= 85;

		if(nColor & 1)
			nByte |= 128;

		if(nColor & 2)
			nByte |= 8;

		if(nColor & 4)
			nByte |= 32;

		if(nColor & 8)
			nByte |= 2;
	}
	else
	{
		nByte &= 170;

		if(nColor & 1)
			nByte |= 64;

		if(nColor & 2)
			nByte |= 4;

		if(nColor & 4)
			nByte |= 16;

		if(nColor & 8)
			nByte |= 1;
	}

	*pByteAddress = nByte;
}

void main()
{
	unsigned char *pScreen = (unsigned char *)0xC000;
	unsigned int nLine = 0;
	unsigned int nColumn = 0;
	unsigned char nColor = 0;
	unsigned char nPixel = 0;

	//SCR_SET_MODE 0
	__asm
		ld	a, #0
		call	#0xBC0E
	__endasm;

	for(nColumn = 0; nColumn < 160; nColumn++)
	{
		nColor = (nColor + 1) % 16;
		nPixel = nColumn % 2;

		for(nLine = 0; nLine < 200; nLine++)
		{
			pScreen = GetLineAddress(nLine) + nColumn / 2;
			SetMode0PixelColor(pScreen, nColor, nPixel);
		}
	}

	//KM_WAIT_CHAR	
	__asm
		call #0xBB06
	__endasm;	
}
